package com.example.controller;

import com.example.config.annotation.IgnoreAuth;
import com.example.entity.WzHouseMarketEntity;
import com.example.service.WzHouseMarketService;
import com.example.utils.PageMap;
import com.example.utils.PageUtils;
import com.example.utils.Query;
import com.example.utils.R;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RestController;

import java.util.List;

/**
 * 房屋出租(合同管理)
 */
@RestController
@RequestMapping("/house-car/house/dist/api/wzHouseMarket")
public class WzHouseMarketController {

    @Autowired
    private WzHouseMarketService wzHouseMarketService;

    @RequestMapping("/list")
    @IgnoreAuth
    public R list(@RequestBody PageMap pageMap) {
        //查询列表数据
        Query query = new Query(pageMap);
        List<WzHouseMarketEntity> list = wzHouseMarketService.queryList(query);
        int total = wzHouseMarketService.queryTotal(query);
        PageUtils pageUtil = new PageUtils(list, total, query.getLimit(), query.getPage());
        return R.ok().put("page", pageUtil);
    }

    @RequestMapping("/echartList")
    @IgnoreAuth
    public R echartList(@RequestBody PageMap pageMap) {
//        //查询列表数据
//        Query query = new Query(pageMap);
//        List<WzHouseMarketEntity> wzHouseContracEntityList = wzHouseMarketService.queryList(query);
//
//        WzHouseArrearsManageEntity province=new WzHouseArrearsManageEntity();
//        province.setCity("全省");
//
//        Map<String,List<WzHouseArrearsManageEntity>> map=new HashMap<>();
//        for (WzHouseMarketEntity leaveUseVo : wzHouseContracEntityList) {
//            List<WzHouseArrearsManageEntity> list;
//            if(map.get(leaveUseVo.getCity())!=null){
//                list=map.get(leaveUseVo.getCity());
//                list.add(leaveUseVo);
//            }else{
//                list=new ArrayList<>();
//                list.add(leaveUseVo);
//            }
//            map.put(leaveUseVo.getCity(),list);
//        }
//        List<WzHouseArrearsManageEntity> resultList=new ArrayList<>();
//        List<WzHouseArrearsManageEntity> cityList=new ArrayList<>();
//
//        double allAccumulateArrears=0l;
//        double allmoreThanThreeMonths=0l;
//        double allmoreThanOneYears=0l;
//        double allyearCumulativeNewAdditions=0l;
//        double allyearCumulativeWithdrawal=0l;
//
//        for(Map.Entry<String,List<WzHouseArrearsManageEntity>> entry:map.entrySet()){
//
//            List<WzHouseArrearsManageEntity> list=entry.getValue();
//            if(list.get(0).getCity().equals("全省")){
//                continue;
//            }
//            double contractQuantity=0l;
//            double noTaxContractAmount=0l;
//            double rentArea=0l;
//            double unitPricePerSquareMeter=0l;
//            double yearCumulativeWithdrawal=0l;
//            for (WzHouseArrearsManageEntity leaveUseVo : list) {
////                contractQuantity+=leaveUseVo.getContractQuantity();
////                noTaxContractAmount+=leaveUseVo.getNoTaxContractAmount();
////                rentArea+=leaveUseVo.getRentArea();
////                unitPricePerSquareMeter+=leaveUseVo.getUnitPricePerSquareMeter();
//
//                if(leaveUseVo.getAccumulateArrears()!=null){
//                    allAccumulateArrears+=leaveUseVo.getAccumulateArrears();
//                }
//                if(leaveUseVo.getMoreThanThreeMonths()!=null){
//                    allmoreThanThreeMonths+=leaveUseVo.getMoreThanThreeMonths();
//                }
//                if(leaveUseVo.getMoreThanOneYears()!=null){
//                    allmoreThanOneYears+=leaveUseVo.getMoreThanOneYears();
//                }
//                if(leaveUseVo.getYearCumulativeNewAdditions()!=null){
//                    allyearCumulativeNewAdditions+=leaveUseVo.getYearCumulativeNewAdditions();
//                }
//                if(leaveUseVo.getYearCumulativeWithdrawal()!=null){
//                    allyearCumulativeWithdrawal=leaveUseVo.getYearCumulativeWithdrawal();
//                }
//            }
////            WzHouseContracEntity parent=new WzHouseContracEntity();
////            parent.setContractQuantity(contractQuantity);
////            parent.setNoTaxContractAmount(noTaxContractAmount);
////            parent.setRentArea(rentArea);
////            parent.setUnitPricePerSquareMeter(unitPricePerSquareMeter);
////            parent.setCity(list.get(0).getCity());
////            parent.setCounty(list.get(0).getCounty());
////            parent.setChildren(list);
//            cityList.add(list.get(0));
//        }
//        province.setAccumulateArrears(allAccumulateArrears);
//        province.setMoreThanOneYears(allmoreThanOneYears);
//        province.setMoreThanThreeMonths(allmoreThanThreeMonths);
//        province.setYearCumulativeNewAdditions(allyearCumulativeNewAdditions);
//        province.setYearCumulativeWithdrawal(allyearCumulativeWithdrawal);
//        province.setChildren(cityList);
//        resultList.add(province);
//
//        int total = wzHouseMarketService.queryTotal(query);
//        PageUtils pageUtil = new PageUtils(resultList, total, query.getLimit(), query.getPage());
//        return R.ok().put("page", pageUtil);
        return null;
    }

}
