package com.example.controller;

import com.example.config.annotation.IgnoreAuth;
import com.example.entity.WzStrategyEntity;
import com.example.service.WzStrategyService;
import com.example.utils.PageMap;
import com.example.utils.PageUtils;
import com.example.utils.Query;
import com.example.utils.R;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RestController;

import java.util.Date;
import java.util.List;
import java.util.Map;

/**
 * 房屋出租(合同管理)
 */
@RestController
@RequestMapping("/house-car/house/dist/api/wzStrategy")
public class WzStrategyController {

    @Autowired
    private WzStrategyService wzStrategyService;

    @RequestMapping("/list")
    @IgnoreAuth
    public R list(@RequestBody PageMap pageMap) {
        //查询列表数据
        Query query = new Query(pageMap);
        List<WzStrategyEntity> list = wzStrategyService.queryList(query);
        Query query1 = new Query(pageMap);
        int total = wzStrategyService.queryTotal(query1);
        PageUtils pageUtil = new PageUtils(list, total, query.getLimit(), query.getPage());
        return R.ok().put("page", pageUtil);
    }

    /**
    * 保存
    */
    @RequestMapping("/save")
    @IgnoreAuth
    public R save(@RequestBody WzStrategyEntity bBizItem) {
        bBizItem.setCreator("admin");
        bBizItem.setCreateTime(new Date());
        bBizItem.setType(1);
        wzStrategyService.save(bBizItem);
        return R.ok();
    }

    @RequestMapping("/del")
    @IgnoreAuth
    public R del(@RequestBody Map map) {
        wzStrategyService.delete(Integer.valueOf(map.get("id").toString()));
        return R.ok();
    }

    @RequestMapping("/getObject")
    @IgnoreAuth
    public R getObject(@RequestBody Map map) {
        WzStrategyEntity object = wzStrategyService.getObject(Integer.valueOf(map.get("id").toString()));
        return R.ok().put("object",object);
    }

    @RequestMapping("/getObjectByType")
    @IgnoreAuth
    public R getObjectByType(@RequestBody Map map) {
        WzStrategyEntity object = wzStrategyService.getObjectByType();
        return R.ok().put("object",object);
    }


    /**
     * 保存
     */
    @RequestMapping("/update")
    @IgnoreAuth
    public R update(@RequestBody Map map) {
        if(map.get("type")!=null){
            if(map.get("type").toString().equals("false")){
                map.put("type",0);
            }else{
                map.put("type",1);
            }
        }
        Long id=Long.valueOf(map.get("id").toString());
        map.put("id",id);
        wzStrategyService.update(map);
        return R.ok();
    }
}
