package com.example.entity.house;

import lombok.Data;

import java.math.BigDecimal;
import java.math.RoundingMode;
import java.util.ArrayList;
import java.util.List;

@Data
public class HouseAgeStatPo {
    /**
     * 二级组织机构编码
     */
    private String areaNo;
    /**
     * 二级组织机构名称
     */
    private String areaName;
    /**
     * 三级组织机构编码
     */
    private String cityNo;
    /**
     * 三级组织机构名称
     */
    private String cityName;
    /**
     * 1-10年
     */
    private Integer a1;
    /**
     * 11-20年
     */
    private Integer a2;
    /**
     * 21-30年
     */
    private Integer a3;
    /**
     * 31-40年
     */
    private Integer a4;
    /**
     * 41-50年
     */
    private Integer a5;
    /**
     * 50年以上
     */
    private Integer a6;
    /**
     * 未知房龄
     */
    private Integer au;
    /**
     * 建筑数量
     */
    private Integer total;
    /**
     * 房龄合计
     */
    private Integer houseAgeSum;
    /**
     * 平均房龄
     */
    private BigDecimal houseAgeAvg;
    /**
     * 子列表
     */
    private List<HouseAgeStatPo> children;

    public HouseAgeStatPo() {
        this.areaNo = "";
        this.areaName = "";
        this.cityNo = "";
        this.cityName = "";
        this.a1 = 0;
        this.a2 = 0;
        this.a3 = 0;
        this.a4 = 0;
        this.a5 = 0;
        this.a6 = 0;
        this.au = 0;
        this.total = 0;
        this.houseAgeSum = 0;
        this.houseAgeAvg = BigDecimal.ZERO;
        this.children = new ArrayList<>();
    }

    public HouseAgeStatPo(String areaNo, String areaName) {
        this.areaNo = areaNo;
        this.areaName = areaName;
        this.cityNo = areaNo;
        this.cityName = areaName;
        this.a1 = 0;
        this.a2 = 0;
        this.a3 = 0;
        this.a4 = 0;
        this.a5 = 0;
        this.a6 = 0;
        this.au = 0;
        this.total = 0;
        this.houseAgeSum = 0;
        this.houseAgeAvg = BigDecimal.ZERO;
        this.children = new ArrayList<>();
    }

    public void update(HouseAgeStatPo po) {
        this.a1 = this.a1 + po.a1;
        this.a2 = this.a2 + po.a2;
        this.a3 = this.a3 + po.a3;
        this.a4 = this.a4 + po.a4;
        this.a5 = this.a5 + po.a5;
        this.a6 = this.a6 + po.a6;
        this.au = this.au + po.au;
        this.total = this.total + po.total;
        this.houseAgeSum = this.houseAgeSum + po.houseAgeSum;
        if (this.total != 0) {
            this.houseAgeAvg = new BigDecimal(this.houseAgeSum)
                    .divide(new BigDecimal(this.total), 2, RoundingMode.HALF_DOWN);
        } else {
//            this.houseAgeAvg = null;
            this.houseAgeAvg = BigDecimal.ZERO;
        }
        this.children.add(po);
    }
}
