package com.example.enums;

public enum ListBuildingOrderEnum {
    /**
     * 二级单位
     */
    city("area_name"),
    /**
     * 三级单位
     */
    county("city_name"),
    /**
     * 建筑别名
     */
    buildingAias("building_name"),
    /**
     * 标准地址
     */
    standardAddress("address"),
    /**
     * 建筑用途
     */
    buildingUse("building_use"),
    /**
     * 建筑面积
     */
    buildingArea("building_area"),
    /**
     * 建筑面积自用
     */
    buildingAreaUseArea("building_area_self_use"),
    /**
     * 建筑面积出租
     */
    buildingAreaRentArea("building_area_rent"),
    /**
     * 建筑面积闲置
     */
    buildingAreaIdelArea("building_area_idle"),
    /**
     * 建筑面积不可使用
     */
    buildingAreaUnavailable("building_area_unusable"),
    /**
     * 一级单位
     */
    province("first_unit"),
    /**
     * 得房率
     */
    buildingRate("housing_acquisition_rate"),
    /**
     * 局址别名
     */
    parentBuildingName("site_name"),
    /**
     * 土地别名
     */
    parentLandName("land_name"),
    /**
     * 房屋来源
     */
    buildingSource("housing_source"),
    /**
     * 取得日期
     */
    getDate("acquisition_date"),
    /**
     * 房龄开始年份
     */
    buildingStartYear("house_year_began"),
    /**
     * 投资主体
     */
    investmentEntity("investor"),
    /**
     * 管理层级
     */
    managementHierarchy("management_level"),
    /**
     * 建筑结构
     */
    buildingStructure("building_structure"),
    /**
     * 楼层总数
     */
    totalNumberOfFloors("total_floors"),
    /**
     * 是否临街
     */
    buildingFaceStreet("frontage"),
    /**
     * 是否有院落
     */
    courtyard("courtyard"),
    /**
     * 整栋是否独有
     */
    wholeBuilding("whole_building"),
    /**
     * 是否有房产证
     */
    premisesPermit("property_ownership_certificate"),
    /**
     * 无房产证原因
     */
    noPremisesPermitReason("no_property_ownership_certificate_reason"),
    /**
     * 未关联资产
     */
    unrelatedAssets("unrelated_assets"),
    /**
     * 资产编号
     */
    assetCode("assets_num"),
    /**
     * 资产标签号
     */
    astsLabe("assets_tag_num"),
    /**
     * 使用状态
     */
    useState("usage_status"),
    /**
     * 权属状态
     */
    ownershipStatus("ownership_status"),
    /**
     * 建筑占地面积(㎡)
     */
    buildingFloorArea("floor_area"),
    /**
     * 使用面积(㎡)
     */
    useArea("usable_area"),
    /**
     * 使用面积-自用(㎡)
     */
    useAreaSelfUseArea("usable_area_self_use"),
    /**
     * 使用面积-出租(㎡)
     */
    useAreaRentArea("usable_area_rent"),
    /**
     * 使用面积-闲置(㎡)
     */
    useAreaIdelArea("usable_area_idle"),
    /**
     * 使用面积-不可使用(㎡)
     */
    useAreaUnavailableArea("usable_area_unusable"),
    /**
     * 楼长姓名
     */
    landManageName("community_assistant_name"),
    /**
     * 楼长单位
     */
    landManageCompany("community_assistant_unit"),
    /**
     * 经度集团
     */
    buildingLongitude("lng_jt"),
    /**
     * 纬度集团
     */
    buildingDimension("lat_jt"),
    /**
     * 实际产权人
     */
    buildingActualPropertyRights("property_owner"),
    /**
     * 局址编号
     */
    buildingAddressNumber("site_num"),
    /**
     * 局址别名
     */
    buildingNameAlias("site_name"),
    /**
     * 地段
     */
    areaSector("area_sector"),
    ;

    private final String columnName;

    ListBuildingOrderEnum(String columnName) {
        this.columnName = columnName;
    }

    public String getColumnName() {
        return columnName;
    }
}
