package com.example.utils;

import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.github.pagehelper.PageInfo;
import lombok.Data;

import java.io.Serializable;
import java.util.List;

/**
 * 分页工具类
 *
 * @author
 * @email 1600148841@qq.com
 * @date 2019/10/14
 */
@Data
public class PageUtils implements Serializable {
    private static final long serialVersionUID = 1L;
    //总记录数
    private Long totalCount;
    //每页记录数
    private Long pageSize;
    //总页数
    private Long totalPage;
    //当前页数
    private Long currPage;
    //列表数据
    private List<?> list;

    public PageUtils(List<?> list, Page page) {
        this.list = list;
        this.totalCount = page.getTotal();
        this.pageSize = page.getSize();
        this.currPage = page.getCurrent();
        this.totalPage = page.getPages();
    }

    /**
     * 分页
     *
     * @param list       列表数据
     * @param totalCount 总记录数
     * @param pageSize   每页记录数
     * @param currPage   当前页数
     */
    public PageUtils(List<?> list, int totalCount, int pageSize, int currPage) {
        this.list = list;
        this.totalCount = (long) totalCount;
        this.pageSize = (long) pageSize;
        this.currPage = (long) currPage;
        this.totalPage = (long) Math.ceil((double) totalCount / pageSize);
    }

    public PageUtils(PageInfo pageInfo) {
        this.list = pageInfo.getList();
        this.totalCount =  pageInfo.getTotal();
        this.pageSize = (long) pageInfo.getPageSize();
        this.currPage = (long) pageInfo.getPageNum();
        this.totalPage = (long) pageInfo.getPages();
    }
}
